<?php

namespace Chippyash\Test\Zend\Acl\Xml;

use Chippyash\Zend\Acl\Xml\RoleBuilder;
use Zend\Permissions\Acl\Acl;

require_once __DIR__ . '/Stubs/TestRoleStub.php';

/**
 * Generated by PHPUnit_SkeletonGenerator on 2014-12-21 at 10:55:51.
 */
class RoleBuilderTest extends \PHPUnit_Framework_TestCase {

    /**
     * @var RoleBuilder
     */
    protected $object;
    /**
     *
     * @var Acl
     */
    protected $acl;
    
    /**
     * Sets up the fixture, for example, opens a network connection.
     * This method is called before a test is executed.
     */
    protected function setUp() {
        $this->acl = new Acl();
        $dom = new \DOMDocument();
        $dom->validateOnParse = true;
        $dom->load(__DIR__ . '/fixtures/test.xml', LIBXML_NONET | (defined('LIBXML_COMPACT') ? LIBXML_COMPACT : 0));
        $this->object = new RoleBuilder($dom, $this->acl);
    }

    public function testBuildItemWillAddRolesToAcl()
    {
        $this->assertFalse($this->acl->hasRole('guest'));
        $this->assertTrue($this->object->buildItem());
        $this->assertTrue($this->acl->hasRole('guest'));
    }
}
